#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Bits Representations
# Generated: Mon Sep 10 14:46:26 2012
##################################################

from PyQt4 import Qt
from gnuradio import eng_notation
from gnuradio import gr
from gnuradio import qtgui
from gnuradio.eng_option import eng_option
from gnuradio.gr import firdes
from optparse import OptionParser
import numpy
import sip
import sys

class bits_representations(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Bits Representations")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Bits Representations")
		self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)

		self.settings = Qt.QSettings("GNU Radio", "bits_representations")
		self.restoreGeometry(self.settings.value("geometry").toByteArray())


		##################################################
		# Variables
		##################################################
		self.samp_rate = samp_rate = 32000

		##################################################
		# Blocks
		##################################################
		self.random_source_x_0_0 = gr.vector_source_s(map(int, numpy.random.randint(0, 2, 1000)), True)
		self.random_source_x_0 = gr.vector_source_s(map(int, numpy.random.randint(0, 2, 1000)), True)
		self.qtgui_time_sink_x_0 = qtgui.time_sink_c(
			1024, #size
			samp_rate, #bw
			"QT GUI Plot", #name
			1 #number of inputs
		)
		self._qtgui_time_sink_x_0_win = sip.wrapinstance(self.qtgui_time_sink_x_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_time_sink_x_0_win, 0,0,1,1)
		self.qtgui_const_sink_x_0 = qtgui.const_sink_c(
			1024, #size
			"QT GUI Plot", #name
			1 #number of inputs
		)
		self._qtgui_const_sink_x_0_win = sip.wrapinstance(self.qtgui_const_sink_x_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_const_sink_x_0_win, 0,1,1,1)
		self.gr_throttle_0 = gr.throttle(gr.sizeof_gr_complex*1, samp_rate)
		self.gr_short_to_float_0_0 = gr.short_to_float(1, 1)
		self.gr_short_to_float_0 = gr.short_to_float(1, 1)
		self.gr_multiply_const_vxx_0 = gr.multiply_const_vcc((2, ))
		self.gr_float_to_complex_0 = gr.float_to_complex(1)
		self.gr_add_const_vxx_0 = gr.add_const_vcc((-1-1j, ))

		##################################################
		# Connections
		##################################################
		self.connect((self.gr_short_to_float_0_0, 0), (self.gr_float_to_complex_0, 1))
		self.connect((self.gr_short_to_float_0, 0), (self.gr_float_to_complex_0, 0))
		self.connect((self.random_source_x_0_0, 0), (self.gr_short_to_float_0_0, 0))
		self.connect((self.random_source_x_0, 0), (self.gr_short_to_float_0, 0))
		self.connect((self.gr_float_to_complex_0, 0), (self.gr_throttle_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.gr_multiply_const_vxx_0, 0))
		self.connect((self.gr_multiply_const_vxx_0, 0), (self.gr_add_const_vxx_0, 0))
		self.connect((self.gr_add_const_vxx_0, 0), (self.qtgui_const_sink_x_0, 0))
		self.connect((self.gr_add_const_vxx_0, 0), (self.qtgui_time_sink_x_0, 0))

# QT sink close method reimplementation
	def closeEvent(self, event):
		self.settings = Qt.QSettings("GNU Radio", "bits_representations")
		self.settings.setValue("geometry", self.saveGeometry())
		event.accept()

	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate

if __name__ == '__main__':
	parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
	(options, args) = parser.parse_args()
	qapp = Qt.QApplication(sys.argv)
	tb = bits_representations()
	tb.start()
	tb.show()
	qapp.exec_()
	tb.stop()
	tb = None #to clean up Qt widgets

