#!/usr/bin/env python
##################################################
# Gnuradio Python Flow Graph
# Title: Mpsk Stage2
# Generated: Sun Sep 23 16:18:29 2012
##################################################

from PyQt4 import Qt
from gnuradio import digital
from gnuradio import eng_notation
from gnuradio import filter
from gnuradio import gr
from gnuradio.eng_option import eng_option
from gnuradio.filter import firdes
from gnuradio.gr import firdes
from gnuradio.qtgui import qtgui
from optparse import OptionParser
import PyQt4.Qwt5 as Qwt
import math
import numpy
import sip
import sys

class mpsk_stage2(gr.top_block, Qt.QWidget):

	def __init__(self):
		gr.top_block.__init__(self, "Mpsk Stage2")
		Qt.QWidget.__init__(self)
		self.setWindowTitle("Mpsk Stage2")
		self.setWindowIcon(Qt.QIcon.fromTheme('gnuradio-grc'))
		self.top_scroll_layout = Qt.QVBoxLayout()
		self.setLayout(self.top_scroll_layout)
		self.top_scroll = Qt.QScrollArea()
		self.top_scroll.setFrameStyle(Qt.QFrame.NoFrame)
		self.top_scroll_layout.addWidget(self.top_scroll)
		self.top_scroll.setWidgetResizable(True)
		self.top_widget = Qt.QWidget()
		self.top_scroll.setWidget(self.top_widget)
		self.top_layout = Qt.QVBoxLayout(self.top_widget)
		self.top_grid_layout = Qt.QGridLayout()
		self.top_layout.addLayout(self.top_grid_layout)


		##################################################
		# Variables
		##################################################
		self.time_offset = time_offset = 1.00
		self.taps = taps = [1.0, 0.25-0.25j, 0.50 + 0.10j, -0.3 + 0.2j, 0.1 - 0.01j, -0.2 + 0.2j]
		self.sps = sps = 4
		self.samp_rate = samp_rate = 32000
		self.noise_volt = noise_volt = 0.0001
		self.freq_offset = freq_offset = 0
		self.arity = arity = 4

		##################################################
		# Blocks
		##################################################
		self._time_offset_layout = Qt.QVBoxLayout()
		self._time_offset_label = Qt.QLabel("Channel: Timing Offset")
		self._time_offset_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
		self._time_offset_slider.setRange(0.999, 1.001, 0.0001)
		self._time_offset_slider.setValue(self.time_offset)
		self._time_offset_slider.setMinimumWidth(200)
		self._time_offset_slider.valueChanged.connect(self.set_time_offset)
		self._time_offset_label.setAlignment(Qt.Qt.AlignBottom | Qt.Qt.AlignHCenter)
		self._time_offset_layout.addWidget(self._time_offset_label)
		self._time_offset_layout.addWidget(self._time_offset_slider)
		self.top_layout.addLayout(self._time_offset_layout)
		self._noise_volt_layout = Qt.QVBoxLayout()
		self._noise_volt_label = Qt.QLabel("Channel: Noise Voltage")
		self._noise_volt_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
		self._noise_volt_slider.setRange(0, 1, 0.01)
		self._noise_volt_slider.setValue(self.noise_volt)
		self._noise_volt_slider.setMinimumWidth(200)
		self._noise_volt_slider.valueChanged.connect(self.set_noise_volt)
		self._noise_volt_label.setAlignment(Qt.Qt.AlignBottom | Qt.Qt.AlignHCenter)
		self._noise_volt_layout.addWidget(self._noise_volt_label)
		self._noise_volt_layout.addWidget(self._noise_volt_slider)
		self.top_layout.addLayout(self._noise_volt_layout)
		self._freq_offset_layout = Qt.QVBoxLayout()
		self._freq_offset_label = Qt.QLabel("Channel: Frequency Offset")
		self._freq_offset_slider = Qwt.QwtSlider(None, Qt.Qt.Horizontal, Qwt.QwtSlider.BottomScale, Qwt.QwtSlider.BgSlot)
		self._freq_offset_slider.setRange(-0.1, 0.1, 0.001)
		self._freq_offset_slider.setValue(self.freq_offset)
		self._freq_offset_slider.setMinimumWidth(200)
		self._freq_offset_slider.valueChanged.connect(self.set_freq_offset)
		self._freq_offset_label.setAlignment(Qt.Qt.AlignBottom | Qt.Qt.AlignHCenter)
		self._freq_offset_layout.addWidget(self._freq_offset_label)
		self._freq_offset_layout.addWidget(self._freq_offset_slider)
		self.top_layout.addLayout(self._freq_offset_layout)
		self.random_source_x_0 = gr.vector_source_b(map(int, numpy.random.randint(0, 256, 1000000)), True)
		self.qtgui_sink_x_0_1 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			True, #plotfreq
			False, #plotwaterfall
			False, #plottime
			False, #plotconst
		)
		self._qtgui_sink_x_0_1_win = sip.wrapinstance(self.qtgui_sink_x_0_1.pyqwidget(), Qt.QWidget)
		self.top_layout.addWidget(self._qtgui_sink_x_0_1_win)
		self.qtgui_sink_x_0_0 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			False, #plotfreq
			False, #plotwaterfall
			False, #plottime
			True, #plotconst
		)
		self._qtgui_sink_x_0_0_win = sip.wrapinstance(self.qtgui_sink_x_0_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_sink_x_0_0_win, 0,1,1,1)
		self.qtgui_sink_x_0 = qtgui.sink_c(
			1024, #fftsize
			firdes.WIN_BLACKMAN_hARRIS, #wintype
			0, #fc
			samp_rate, #bw
			"QT GUI Plot", #name
			False, #plotfreq
			False, #plotwaterfall
			True, #plottime
			False, #plotconst
		)
		self._qtgui_sink_x_0_win = sip.wrapinstance(self.qtgui_sink_x_0.pyqwidget(), Qt.QWidget)
		self.top_grid_layout.addWidget(self._qtgui_sink_x_0_win, 0,0,1,1)
		self.gr_throttle_0 = gr.throttle(gr.sizeof_gr_complex*1, samp_rate)
		self.gr_multiply_const_vxx_0 = gr.multiply_const_vcc((complex(.5,.5), ))
		self.digital_psk_mod_0 = digital.psk.psk_mod(
		  constellation_points=arity,
		  mod_code="gray",
		  differential=True,
		  samples_per_symbol=sps,
		  excess_bw=0.35,
		  verbose=False,
		  log=False,
		  )
		self.channel_model_0 = filter.channel_model(
			noise_voltage=noise_volt,
			frequency_offset=freq_offset,
			epsilon=time_offset,
			taps=(taps),
			noise_seed=0,
		)

		##################################################
		# Connections
		##################################################
		self.connect((self.digital_psk_mod_0, 0), (self.gr_multiply_const_vxx_0, 0))
		self.connect((self.random_source_x_0, 0), (self.digital_psk_mod_0, 0))
		self.connect((self.gr_multiply_const_vxx_0, 0), (self.channel_model_0, 0))
		self.connect((self.channel_model_0, 0), (self.gr_throttle_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0_0, 0))
		self.connect((self.gr_throttle_0, 0), (self.qtgui_sink_x_0_1, 0))

	def get_time_offset(self):
		return self.time_offset

	def set_time_offset(self, time_offset):
		self.time_offset = time_offset
		self._time_offset_slider.setValue(self.time_offset)
		self.channel_model_0.set_timing_offset(self.time_offset)

	def get_taps(self):
		return self.taps

	def set_taps(self, taps):
		self.taps = taps
		self.channel_model_0.set_taps((self.taps))

	def get_sps(self):
		return self.sps

	def set_sps(self, sps):
		self.sps = sps

	def get_samp_rate(self):
		return self.samp_rate

	def set_samp_rate(self, samp_rate):
		self.samp_rate = samp_rate
		self.qtgui_sink_x_0.set_frequency_range(0, self.samp_rate)
		self.qtgui_sink_x_0_1.set_frequency_range(0, self.samp_rate)
		self.qtgui_sink_x_0_0.set_frequency_range(0, self.samp_rate)

	def get_noise_volt(self):
		return self.noise_volt

	def set_noise_volt(self, noise_volt):
		self.noise_volt = noise_volt
		self._noise_volt_slider.setValue(self.noise_volt)
		self.channel_model_0.set_noise_voltage(self.noise_volt)

	def get_freq_offset(self):
		return self.freq_offset

	def set_freq_offset(self, freq_offset):
		self.freq_offset = freq_offset
		self._freq_offset_slider.setValue(self.freq_offset)
		self.channel_model_0.set_frequency_offset(self.freq_offset)

	def get_arity(self):
		return self.arity

	def set_arity(self, arity):
		self.arity = arity

if __name__ == '__main__':
	parser = OptionParser(option_class=eng_option, usage="%prog: [options]")
	(options, args) = parser.parse_args()
	qapp = Qt.QApplication(sys.argv)
	tb = mpsk_stage2()
	tb.start()
	tb.show()
	qapp.exec_()
	tb.stop()

